/* Test Program for AUSPICE-R
 * Author: Jiaqi Tan <tanjiaqi@cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#include <swi_functions.h>

#define MAX 255
char curr_line[MAX+1];
char tmp_word_str[MAX+1];

/* wc: wordcount
 * counts number of words in file (or stdin)
 */
int main(int argc, char **argv) {
  char *filename;
  int fd, chars_read;
  int i, curr_strlen;
  int words = 0;

  if (argc >= 2) {
    filename = argv[1];
    fd = c_open(filename, O_RDONLY);
    if (fd < 0) {
      c_write(STDOUT_FILENO, "could not open file\n", 20);
      c_exit(-1);
    }
  } else {
    fd = STDIN_FILENO;
  }

  do {
    chars_read = read_line(fd, curr_line, MAX);
    if (chars_read <= 0) break;

    curr_strlen = strlen(curr_line);
    for (i = 0; i < curr_strlen; i++) {
      if (i > 1 && is_printable(curr_line[i-1]) && (!is_printable(curr_line[i]))) {
	words++;
      }
    }
  } while (1);

  itoa(words, (char *)tmp_word_str, MAX);
  curr_strlen = strlen(tmp_word_str);
  c_write(STDOUT_FILENO, tmp_word_str, curr_strlen);
  c_write(STDOUT_FILENO, "\n", 1);
  c_exit(0);  
}
