/* Test Program for AUSPICE-R
 * Author: Jiaqi Tan <tanjiaqi@cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#include <swi_functions.h>

#define MAX 255
char curr_line[MAX+1];
char tmp_word_str[MAX+1];

/* grep: grep for simple patterns
 */
int main(int argc, char **argv) {
  char *filename;
  char *needle;
  int fd, chars_read;
  int i, curr_strlen, needle_len;
  int words = 0;

  if (argc >= 3) {
    filename = argv[2];
    fd = c_open(filename, O_RDONLY);
    if (fd < 0) {
      c_write(STDOUT_FILENO, "could not open file\n", 20);
      c_exit(-1);
    }
  } else {
    fd = STDIN_FILENO;
  }

  if (argc >= 2) {
    needle = argv[1];
  } else {
    c_write(STDOUT_FILENO, "no search term\n", 15);
    c_exit(-1);
  }

  needle_len = strlen(needle);

  do {
    chars_read = read_line(fd, curr_line, MAX);
    if (chars_read <= 0) break;
    curr_strlen = strlen(curr_line);
    if (strpos(curr_line, curr_strlen, needle, needle_len) >= 0) {
      c_write(STDOUT_FILENO, curr_line, curr_strlen);
    }
  } while (1);

  c_exit(0);  
}
