/* Test Program for AUSPICE-R
 * Author: Jiaqi Tan <tanjiaqi@cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#include <swi_functions.h>
#include <rpi_defines.h>
#include <rpi.h>

#define LED_GPIO 7
#define LIGHT_SENSOR_GPIO 8 //29

int RCtime(int pin) {
  int reading = 0;
  pinMode(pin, OUTPUT);
  digitalWrite(pin, LOW);
  delay(100);

  pinMode(pin, INPUT);
  while (digitalRead(pin) == LOW) {
    reading++;
    if (reading >= 15000) break;
  }

#ifdef VERBOSE    
  int i = 0;
  c_write(1, "RCtime: \n", 9);
  for (i = 0; i < reading; i+=100) {
    c_write(1, "#", 1);
  }
#endif
    
  return (reading % 15000);
}

int main(void) {
    int reading;
    if (setup_piModel1_rev2() < 0) return(-1);

    pinMode(LED_GPIO, OUTPUT);

    while (1) {
      reading = RCtime(LIGHT_SENSOR_GPIO);
#ifdef VERBOSE
      c_write(1, "Reading: \n", 9);
      int i = 0;
      for (i = 0; i < reading; i+= 10) {
	c_write(1, "@", 1);
      }
      c_write(1, "\n", 1);
#endif        
      digitalWrite(LED_GPIO, HIGH);
      delay(reading);
      digitalWrite(LED_GPIO, LOW);
      delay(reading);
    }
	
    return(0);
}

