/* Test Program for AUSPICE-R
 * Author: Jiaqi Tan <tanjiaqi@cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#define _PRINT
#define _EXIT

#ifdef PRINT
#include <stdio.h>
#endif // PRINT

#ifdef EXIT
#include <swi_functions.h>
#endif // EXIT

#ifdef SAFETY
#define MIN_SAFE_MEM 0x81C0
#define WORD_SIZE 4
#define ABS_MAX_SAFE_MEM 0xBF000000
#define MAX_SAFE_MEM ((unsigned int) (ABS_MAX_SAFE_MEM - WORD_SIZE))
#include <safety.h>
#endif
		
char str1[45] = "abcdefghijklmnopqrst";
char str2[45] = "";
int arr1[10] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 0};
int arr2[10] = {0};

void arrcpy (int *src, int *dst, int n) 
{
  unsigned int i;
#ifdef SAFETY
  register unsigned int r11_val asm ("r4");
#endif
    
#ifdef PRINT
  printf("arrcpy: start value of dst: %x\n", (unsigned int) (dst));
#endif

  for (i=0; i < n; ++i) {
#ifdef PRINT
    printf("i: %d \tdst[i]: %x\n", i, (unsigned int) (dst+i));
#endif
#ifdef SAFETY
	SAFETY_CHECK((unsigned int)(dst+i), r11_val, 2, dst[i] = src[i])
#else
    dst[i] = src[i];
#endif
  }
  return;
}

int main (int argc, char **argv)
{
  int i;

#ifdef PRINT
  printf("arrcpy1: start\n");
  printf("arr2 before: ");
  for (i = 0; i < 10; i++) { printf("%d ",arr2[i]); }
  printf("\n");
#endif

#ifdef PRINT
      printf("arrcpy1: copying\n");
#endif
  arrcpy(arr1, arr2, 10);
#ifdef PRINT
  printf("arrcpy1: complete\n");
#endif
  
#ifdef PRINT
  printf("arr2 after:\n");
  for (i = 0; i < 10; i++) { printf("%d ",arr2[i]); }
  printf("\n");
#endif
  
#ifdef EXIT
  _exit(0);
#else
  return(0);
#endif // EXIT
}

