/* Test Program for AUSPICE-R
 * Author: Jiaqi Tan <tanjiaqi@cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#define _PRINT
#define _EXIT

#ifdef PRINT
#include <stdio.h>
#endif // PRINT

#ifdef EXIT
#include <unistd.h>
#endif // EXIT

#ifdef SAFETY
#define MIN_SAFE_MEM 0x82C8
#define WORD_SIZE 4
#define ABS_MAX_SAFE_MEM 0xBF000000
#define MAX_SAFE_MEM ((unsigned int) (ABS_MAX_SAFE_MEM - WORD_SIZE))
#include <safety.h>
#endif

void sort (int arr[], int arrlen) 
{
  int i, j, tmp;
  register unsigned int r11_val asm ("r4");

  for (i = arrlen-1; i > 0; i--) {
    for (j = 0; j < i; j++) {
      if (arr[j] > arr[j+1]) {
        tmp = arr[j];
#ifdef SAFETY
        SAFETY_CHECK((arr+j), r11_val, 2, arr[j] = arr[j+1]);
        SAFETY_CHECK((arr+j+1), r11_val, 2, arr[j+1] = tmp);
#else
        arr[j] = arr[j+1];
        arr[j+1] = tmp;
#endif
      }
    }
  }
  
}

int nums[5] = { 3, 4, 5, 2, 1 };

int main() {
  int i,j,k;
  int numslen = 5;

#ifdef PRINT
  for (i = 0; i < numslen; i++) {
    printf("%d ", nums[i]);
  }
  printf("\n");

  for (i = 0; i < myargc; i++) {
    printf("%s\n",myargv[i]);
  }
#endif // PRINT

    sort(nums, numslen);

#ifdef PRINT
  for (i = 0; i < numslen; i++) {
    printf("%d ", nums[i]);
  }
  printf("\n");
#endif // PRINT
  
#ifdef EXIT
  _exit(0);
#else
  return(0);
#endif // EXIT
}


