/* Test Program for AUSPICE-R
 * Authors: Jiaqi Tan <tanjiaqi@cmu.edu>, Hui Jun Tay <htay@andrew.cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan, Hui Jun Tay
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#include "stddef.h"

#ifdef SAFETY
#define MIN_SAFE_MEM 0x8838
#define WORD_SIZE 4
#define DOUBLE_WORD_SIZE 8
#define ABS_MAX_SAFE_MEM 0xBF000000
#define MAX_SAFE_MEM ((unsigned int) (ABS_MAX_SAFE_MEM - WORD_SIZE))
#include <safety.h>
#endif

#undef memcpy
// simple implementation
void* memcpy(void *dest, const void *source, size_t num) {
    int i = 0;
    register unsigned int r11_val asm ("r4");
    
    // casting pointers
    char *dest8 = (char *)dest;
    char *source8 = (char *)source;
    for (i = 0; i < num; i++) {
#ifdef SAFETY
		SAFETY_CHECK((dest8+i), r11_val, 1, dest8[i] = source8[i]);
#else
        dest8[i] = source8[i];
#endif
    }
    return dest;
}
