/* Test Program for AUSPICE-R
 * Authors: Jiaqi Tan <tanjiaqi@cmu.edu>, Hui Jun Tay <htay@andrew.cmu.edu>
 * Modifications Copyright (c) 2016 Jiaqi Tan, Hui Jun Tay
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 * Originally part of the WiringPi library (http://wiringpi.com)
 * Modified to add safety-checks for AUSPICE and AUSPICE-R
 */

/*
 * wiringPi:
 *	Arduino compatable (ish) Wiring library for the Raspberry Pi
 *	Copyright (c) 2012 Gordon Henderson
 ***********************************************************************
 * This file is part of wiringPi:
 *	https://projects.drogon.net/raspberry-pi/wiringpi/
 *
 *    wiringPi is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU Lesser General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    wiringPi is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public License
 *    along with wiringPi.  If not, see <http://www.gnu.org/licenses/>.
 ***********************************************************************
 */

/* lcd.h */

#ifndef __RPI_H_
#define __RPI_H_

void lcdHome        (const int fd) ;
void lcdClear       (const int fd) ;
void lcdDisplay     (const int fd, int state) ;
void lcdCursor      (const int fd, int state) ;
void lcdCursorBlink (const int fd, int state) ;
void lcdSendCommand (const int fd, unsigned char command) ;
void lcdPosition    (const int fd, int x, int y) ;
void lcdCharDef     (const int fd, int index, unsigned char data [8]) ;
void lcdPutchar     (const int fd, unsigned char data) ;
void lcdPuts        (const int fd, const char *string) ;
// void lcdPrintf      (const int fd, const char *message, ...) ;

int  lcdInit (const int rows, const int cols, const int bits,
		const int rs, const int strb,
		const int d0, const int d1, const int d2, const int d3, const int d4,
		const int d5, const int d6, const int d7) ;

#endif // __RPI_H_
