/* Test Program for AUSPICE-R
 * Author: Jiaqi Tan <tanjiaqi@cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#include <swi_functions.h>
#include <safety.h>

#define MAX_READ 1

#ifdef SAFETY
#define WORD_SIZE 4

#ifndef ABS_MAX_SAFE_MEM
#define ABS_MAX_SAFE_MEM 0xBF000000
#endif

#ifndef MIN_SAFE_MEM
#define MIN_SAFE_MEM 0x9FFF
#endif

#endif

void *c_memcpy(unsigned char *dst, unsigned char *src, unsigned int n) 
{
  int i;
#ifdef SAFETY
   register unsigned int r11_val asm ("r4");
#endif

  for (i = 0; i < n; i++) {
#ifdef SAFETY
    SAFETY_CHECK((unsigned int)(dst+i), r11_val, 2, dst[i] = src[i]);
#else
    dst[i] = src[i];
#endif
  }
  
  return dst;
}
