/* Test Program for AUSPICE-R
 * Author: Jiaqi Tan <tanjiaqi@cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#include <swi_functions.h>
#include <safety.h>

#define MAX_READ 1

#ifdef SAFETY
#define WORD_SIZE 4

#ifndef ABS_MAX_SAFE_MEM
#define ABS_MAX_SAFE_MEM 0xBF000000
#endif

#ifndef MIN_SAFE_MEM
#define MIN_SAFE_MEM 0x9FFF
#endif

#endif

void *c_memset(void *s, int c, size_t n) {
  int i;
  char *p;
#ifdef SAFETY
   register unsigned int r11_val asm ("r4");
#endif

  for (i = 0; i < n; i++) {
    p = (s+i);
#ifdef SAFETY
    SAFETY_CHECK(p, r11_val, 2, *p = (char) c);
#else
    *p = (char) c;
#endif
  }
  return s;
}
