/* Test Program for AUSPICE-R
 * Author: Jiaqi Tan <tanjiaqi@cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#include <swi_functions.h>
#include <safety.h>

#define MAX_READ 1

#ifdef SAFETY
#define WORD_SIZE 4

#ifndef ABS_MAX_SAFE_MEM
#define ABS_MAX_SAFE_MEM 0xBF000000
#endif

#ifndef MIN_SAFE_MEM
#define MIN_SAFE_MEM 0x9FFF
#endif

#endif

int itoa(int num, char *buf, int maxlen)
{
  int i, curr_remainder;
  char curr_char, *tmp_char;
#ifdef SAFETY
   register unsigned int r11_val asm ("r4");
#endif
  
  i = 0;
  if (num == 0) {
    tmp_char = (char *) (buf + i);
#ifdef SAFETY
    GET_FRAME_POINTER(r11_val);
    if (((unsigned int)(tmp_char) <= MAX_SAFE_MEM) &&
	((unsigned int)(tmp_char) >= MIN_SAFE_MEM) &&
	((unsigned int)(tmp_char) < (r11_val - (3 * WORD_SIZE))) && 
	(r11_val >= (3 * WORD_SIZE))) {
#endif
      *tmp_char = '0';
#ifdef SAFETY
    }
#endif
    i++;
  }
  while (num > 0 && i < (maxlen-1)) {
    curr_remainder = num % 10;
    num = (int) (num / 10);
    /*
    switch(curr_remainder) {
    case 0: curr_char = '0'; break;
    case 1: curr_char = '1'; break;
    case 2: curr_char = '2'; break;
    case 3: curr_char = '3'; break;
    case 4: curr_char = '4'; break;
    case 5: curr_char = '5'; break;
    case 6: curr_char = '6'; break;
    case 7: curr_char = '7'; break;
    case 8: curr_char = '8'; break;
    case 9: curr_char = '9'; break;
    }
    */
    if (curr_remainder == 0) curr_char = '0';
    else if (curr_remainder == 1) curr_char = '1';
    else if (curr_remainder == 2) curr_char = '2';
    else if (curr_remainder == 3) curr_char = '3';
    else if (curr_remainder == 4) curr_char = '4';
    else if (curr_remainder == 5) curr_char = '5';
    else if (curr_remainder == 6) curr_char = '6';
    else if (curr_remainder == 7) curr_char = '7';
    else if (curr_remainder == 8) curr_char = '8';
    else if (curr_remainder == 9) curr_char = '9';

    tmp_char = (char *) (buf + i);
#ifdef SAFETY
    GET_FRAME_POINTER(r11_val);
    if (((unsigned int)(tmp_char) <= MAX_SAFE_MEM) &&
	((unsigned int)(tmp_char) >= MIN_SAFE_MEM) &&
	((unsigned int)(tmp_char) < (r11_val - (3 * WORD_SIZE))) && 
	(r11_val >= (3 * WORD_SIZE))) {
#endif
      *tmp_char = curr_char;
#ifdef SAFETY
    }
#endif
    i++;
  }

  tmp_char = (char *) (buf + i);
#ifdef SAFETY
  GET_FRAME_POINTER(r11_val);
  if (((unsigned int)(tmp_char) <= MAX_SAFE_MEM) &&
      ((unsigned int)(tmp_char) >= MIN_SAFE_MEM) &&
      ((unsigned int)(tmp_char) < (r11_val - (3 * WORD_SIZE))) && 
      (r11_val >= (3 * WORD_SIZE))) {
#endif
    *tmp_char = '\0';
#ifdef SAFETY
  }
#endif

  strrev(buf,maxlen);

  return (i-1);
}
