/* Test Program for AUSPICE-R
 * Author: Jiaqi Tan <tanjiaqi@cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#include <swi_functions.h>
#include <safety.h>

#ifndef MAX_READ
#define MAX_READ 1
#endif

#ifdef SAFETY
#define WORD_SIZE 4
#endif

#ifndef ABS_MAX_SAFE_MEM
#define ABS_MAX_SAFE_MEM 0xBF000000
#endif

#ifndef MIN_SAFE_MEM
#define MIN_SAFE_MEM 0x9FFF
#endif


static char read_line_tmp_buf[MAX_READ+1];
static int num_chars_leftover = 0;

int read_line(int fd, char *buf, int buflen) 
{
  int tmp_chars_read, chars_read, num_chars_to_read, i, curr_chars_read;
  char *tmpbuf, *tmp_char_ptr, tmp_char;
#ifdef SAFETY
  register unsigned int r11_val asm ("r4");
#endif

  tmpbuf = buf;
  chars_read = 0;

  do {

	  if (num_chars_leftover > 0) {
      c_lseek(fd, - num_chars_leftover, SEEK_CUR);
    }

#ifdef SAFETY
#if MAX_READ == 1
    GET_FRAME_POINTER(r11_val);
    if (((unsigned int)(read_line_tmp_buf) <= MAX_SAFE_MEM) &&
	((unsigned int)(read_line_tmp_buf) >= MIN_SAFE_MEM) &&
	((unsigned int)(read_line_tmp_buf) < (r11_val - (19 * WORD_SIZE))) && 
	(r11_val >= (19 * WORD_SIZE))) {
#else
      GET_FRAME_POINTER(r11_val);
      if (((unsigned int)(read_line_tmp_buf+MAX_READ) <= MAX_SAFE_MEM) &&
	  ((unsigned int)(read_line_tmp_buf) >= MIN_SAFE_MEM) &&
	  ((unsigned int)(read_line_tmp_buf+MAX_READ) < (r11_val - (19 * WORD_SIZE))) && 
	  (r11_val >= (19 * WORD_SIZE))) {
#endif
#endif
	tmp_chars_read = c_read(fd, read_line_tmp_buf, MAX_READ);
#ifdef SAFETY
      }
#endif
	
      if (tmp_chars_read == 0) break; // EOF
    
      // copy output from read_line_leftover_buf into buf
      tmp_char_ptr = &(read_line_tmp_buf[0]);
      curr_chars_read = 0;
      for (i = 0; i < tmp_chars_read; i++) {
	tmp_char = *tmp_char_ptr;
#ifdef SAFETY
	SAFETY_CHECK(tmpbuf, r11_val, 3, *tmpbuf = tmp_char);
#else
	*tmpbuf = tmp_char;
#endif
	tmpbuf++;
	chars_read++;
	tmp_char_ptr++;
	curr_chars_read++;
	if (chars_read >= buflen || tmp_char == '\n') break;
      }

#ifdef SAFETY
      SAFETY_CHECK(&num_chars_leftover, r11_val, 3, num_chars_leftover = tmp_chars_read - curr_chars_read);
#else
      num_chars_leftover = tmp_chars_read - curr_chars_read;
#endif

      if (chars_read >= buflen || tmp_char == '\n') break;

    } while (1); 

#ifdef SAFETY
    GET_FRAME_POINTER(r11_val);
    if (((unsigned int)(tmpbuf) <= MAX_SAFE_MEM) &&
	((unsigned int)(tmpbuf) >= MIN_SAFE_MEM) &&
	((unsigned int)(tmpbuf) < (r11_val - (3 * WORD_SIZE))) && 
	(r11_val >= (3 * WORD_SIZE))) {
#endif
      *tmpbuf = '\0';
#ifdef SAFETY
    }
#endif
    return(chars_read);
  }
