/* Test Program for AUSPICE-R
 * Author: Jiaqi Tan <tanjiaqi@cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#ifndef SAFETY_H
#define SAFETY_H

#define WORD_SIZE 4
#define MAX_SAFE_MEM ((unsigned int) (ABS_MAX_SAFE_MEM - WORD_SIZE))

#ifndef GET_FRAME_POINTER
#define GET_FRAME_POINTER(dest_var)		\
  asm ( "mov r4,r11"				\
	: "=r" (dest_var)			\
	: /* no inputs */			\
	: /* no clobber */)			
#endif
#ifndef SAFETY_CHECK
#define SAFETY_CHECK(addr, fp_var, stack_size, op)  GET_FRAME_POINTER(r11_val);	\
  if (((unsigned int)(addr) >= MIN_SAFE_MEM) &&					\
      ((unsigned int)(addr) <= MAX_SAFE_MEM) &&					\
      ((unsigned int)(addr) < ((fp_var)-((stack_size)*WORD_SIZE))) &&			\
      ((fp_var) >= ((stack_size)*WORD_SIZE))) { op; } 
#endif

#endif // SAFETY_H
