/* Test Program for AUSPICE-R
 * Author: Jiaqi Tan <tanjiaqi@cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#include <swi_functions.h>
#include <safety.h>

#define MAX_READ 1

#ifdef SAFETY
#define WORD_SIZE 4

#ifndef ABS_MAX_SAFE_MEM
#define ABS_MAX_SAFE_MEM 0xBF000000
#endif

#ifndef MIN_SAFE_MEM
#define MIN_SAFE_MEM 0x9FFF
#endif

#endif

#define MAX_REV_BUF 100
//static char rev_buf[MAX_REV_BUF+1];

int strrev(char *src, int maxlen) 
{
  int i;
  int len;
  char rev_buf[MAX_REV_BUF+1], *tmp_char;
#ifdef SAFETY
   register unsigned int r11_val asm ("r4");
#endif

  len = strlen(src);
  if (len > maxlen) return(-1);
  for (i = 0; i < len; i++) {
    tmp_char = (char *)(rev_buf+(len-i-1));
#ifdef SAFETY
    GET_FRAME_POINTER(r11_val);
    if (((unsigned int)(tmp_char) <= MAX_SAFE_MEM) &&
	((unsigned int)(tmp_char) >= MIN_SAFE_MEM) &&
	((unsigned int)(tmp_char) < (r11_val - (3 * WORD_SIZE))) && 
	(r11_val >= (3 * WORD_SIZE))) {
#endif
      *tmp_char = *(src+i);
#ifdef SAFETY
    }
#endif
  }
  for (i = 0; i < len; i++) {
    tmp_char = (char *)(src+i);
#ifdef SAFETY
    GET_FRAME_POINTER(r11_val);
    if (((unsigned int)(tmp_char) <= MAX_SAFE_MEM) &&
	((unsigned int)(tmp_char) >= MIN_SAFE_MEM) &&
	((unsigned int)(tmp_char) < (r11_val - (3 * WORD_SIZE))) && 
	(r11_val >= (3 * WORD_SIZE))) {
#endif
      *tmp_char = rev_buf[i];
#ifdef SAFETY
    }
#endif
  }
  tmp_char++;
#ifdef SAFETY
  GET_FRAME_POINTER(r11_val);
  if (((unsigned int)(tmp_char) <= MAX_SAFE_MEM) &&
      ((unsigned int)(tmp_char) >= MIN_SAFE_MEM) &&
      ((unsigned int)(tmp_char) < (r11_val - (3 * WORD_SIZE))) && 
      (r11_val >= (3 * WORD_SIZE))) {
#endif
    *tmp_char = '\0';
#ifdef SAFETY
  }
#endif

  return(i);
}
