/* Test Program for AUSPICE-R
 * Author: Jiaqi Tan <tanjiaqi@cmu.edu>
 * Copyright (c) 2016 Jiaqi Tan
 * 15 June 2016
 * 
 * The AUSPICE-R Test Programs are distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  
 *
 */

#include <types.h>

#define O_RDONLY	0x0000
#define O_WRONLY	0x0001
#define O_RDWR		0x0002
#define O_ACCMODE	0x0003

#define O_BINARY	0x0004	/* must fit in char, reserved by dos */
#define O_TEXT		0x0008	/* must fit in char, reserved by dos */
#define O_NOINHERIT	0x0080	/* DOS-specific */

#define O_CREAT		0x0100	/* second byte, away from DOS bits */
#define O_EXCL		0x0200
#define O_NOCTTY	0x0400
#define O_TRUNC		0x0800
#define O_APPEND	0x1000
#define O_NONBLOCK	0x2000

#define O_SYNC          00010000
#define O_CLOEXEC       02000000 

#define PROT_READ       0x1
#define PROT_WRITE      0x2
#define MAP_SHARED      0x01 

/* Values for whence in fseek and lseek */
#define SEEK_SET 0
#define SEEK_CUR 1
#define SEEK_END 2

#define STDIN_FILENO  0
#define STDOUT_FILENO 1

/*
 * syscall wrappers
 */
void c_exit(int status);
ssize_t c_write(int fd, const void *buf, size_t count);
ssize_t c_read(int fd, void *buf, size_t count);
int c_open(const char *pathname, int flags);
int c_close(int fd);
void *c_mmap(void *addr, size_t length, int prot, int flags,
	   int fd, off_t offset);
int c_munmap(void *addr, size_t length);
int c_nanosleep(const struct timespec *req, struct timespec *rem);
off_t c_lseek(int fd, off_t offset, int whence);

/*
 * utility functions
 */
int read_line(int fd, char *buf, int buflen);
int strlen(const char *str);
int itoa(int num, char *buf, int maxlen);
int is_printable(char c);
int strpos(char *haystack, int maxbuflen, char *needle, int needle_len);
int atoi(char *buf, int base);
void *c_memset(void *s, int c, size_t n);
void *c_memcpy(unsigned char *dst, unsigned char *src, unsigned int n);
int isdigit(char c);
int isxdigit(char c);
int islower(char c);
int isspace(char c);
