# SYSCALL_DIR must be defined by whoever is including this file
SOURCES_SYSCALLS = $(SYSCALL_DIR)/_exit.S 
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_write.S 
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_read.S 
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_open.S 
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_close.S 
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_mmap.S 
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_munmap.S
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_nanosleep.S
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_bind.S
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_listen.S
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_socket.S
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_accept.S
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_connect.S
SOURCES_SYSCALLS += $(SYSCALL_DIR)/_lseek.S

SOURCES_BEGIN = $(SYSCALL_DIR)/my_begin.c

OBJ_SYSCALLS = _exit.o
OBJ_SYSCALLS += _write.o
OBJ_SYSCALLS += _read.o
OBJ_SYSCALLS += _open.o
OBJ_SYSCALLS += _close.o
OBJ_SYSCALLS += _mmap.o
OBJ_SYSCALLS += _munmap.o
OBJ_SYSCALLS += _nanosleep.o
OBJ_SYSCALLS += _bind.o
OBJ_SYSCALLS += _listen.o
OBJ_SYSCALLS += _socket.o
OBJ_SYSCALLS += _accept.o
OBJ_SYSCALLS += _connect.o
OBJ_SYSCALLS += _lseek.o

SRC_UTIL = read_line
SRC_UTIL += strlen
SRC_UTIL += strpos
SRC_UTIL += strrev
SRC_UTIL += itoa
SRC_UTIL += atoi
SRC_UTIL += c_memset
SRC_UTIL += c_memcpy
SRC_UTIL += is_char

OBJ_UTIL_SAFE := $(foreach f,$(SRC_UTIL),$(f)_safe.o)
OBJ_UTIL_UNSAFE := $(foreach f,$(SRC_UTIL),$(f).o)

EABI_SOURCES = $(SYSCALL_DIR)/aeabi_uidivmod.S

EABI_OBJS = aeabi_uidivmod.o

OBJ_BEGIN = my_begin.o

MYCFLAGS= -g -O0 -static -fno-exceptions -fno-unwind-tables -fno-asynchronous-unwind-tables -I$(SYSCALL_DIR)

safe_util_unsafe.o: $(SYSCALL_DIR)/safe_util.c
	$(CC) $(MYCFLAGS) -c -o safe_util_unsafe.o $(SYSCALL_DIR)/safe_util.c

safe_util_safe.o: $(SYSCALL_DIR)/safe_util.c
	$(CC) $(MYCFLAGS) -DSAFETY $(EXTRA_CFLAGS) -c -o safe_util_safe.o $(SYSCALL_DIR)/safe_util.c

memcpy.o: $(SYSCALL_DIR)/memcpy.c
	$(CC) $(MYCFLAGS) -c -o memcpy.o $(SYSCALL_DIR)/memcpy.c

memcpy_safe.o: $(SYSCALL_DIR)/memcpy.c
	$(CC) $(MYCFLAGS) -DSAFETY $(EXTRA_CFLAGS) -c -o memcpy.o $(SYSCALL_DIR)/memcpy.c

div.o: $(SYSCALL_DIR)/div.c
	$(CC) $(MYCFLAGS) -c -o div.o $(SYSCALL_DIR)/div.c 

my_begin.o: $(SYSCALL_DIR)/my_begin.c
	$(CC) $(MYCFLAGS) -g -O0 -c -o $@ $<

%_safe.o: $(SYSCALL_DIR)/%.c
	$(CC) $(MYCFLAGS) -DSAFETY $(EXTRA_CFLAGS) -c $< -o $@

%.o: $(SYSCALL_DIR)/%.c
	$(CC) $(MYCFLAGS) -c $< -o $@

#$(OBJ_UTIL_SAFE): %: %.o
#	$(CC) $(MYCFLAGS) -DSAFETY $(EXTRA_CFLAGS) -c $< -o $@

#$(OBJ_UTIL_UNSAFE): %: %.o?
#	$(CC) $(MYCFLAGS) -c $< -o $@

$(OBJ_SYSCALLS): %.o: $(SYSCALL_DIR)/%.S 
	$(CC) $(MYCFLAGS) -g -O0 -c -o $@ $<

$(EABI_OBJS): %.o: $(SYSCALL_DIR)/%.S
	$(CC) $(MYCFLAGS) -g -O0 -c -o $@ $<

#$(OBJ_SYSCALLS): %: %.o: $(SYSCALL_DIR)/%.c
#	$(CC) $(CFLAGS) -g -O0 -c -o $@ $<
